#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    long long n, i, k, x, br = 0, indeks;
    cin >> n >> k >> x;
    long long niz[n];
    if(n == k)
    {
        if(n < 3)
        {
            cout << -1;
            return 0;
        }
        niz[0] = 0;
        niz[1] = x;
        br = 2;
        for(long long a = 0; a < n-3; a++)
        {
            niz[br] = 3*x/2;
            br++;
        }
        niz[br] = 2*x;
    }
    else if(n > k)
    {
        for(long long a = 0; a < k; a++)
        {
            niz[br] = 0;
            br++;
        }
        for(long long a = 0; a < n - k - 1; a++)
        {
            niz[br] = 1;
            br++;
        }
        niz[br] = x;
    }
    else
    {
        long long maxk = 0;
        for(br = 0; br < n; br++)
            {
                niz[br] = br*x;
                maxk += n-br-1;
            }
        long long razlika = maxk - k, s = 0;
        for(long long a = 0; a < n; a++)
        {
            s += a;
            if(s + a + 1 >= razlika)
            {
                indeks = a;
                maxk -= s;
                a = n;
            }
        }
        for(i = 0; i < indeks; i++) niz[i] = niz[indeks];
        razlika = maxk - k;
        for(i = 0; i < razlika; i++) niz[i] = (niz[i] + niz[indeks+1]) / 2;
    }
    cout << niz[0];
    for(br = 1; br < n; br++)
    {
        cout << " " << niz[br];
    }
    return 0;
}